------------------------------
--Radar script by Vectar666	--
--	Shows enemies and your 	--
--		rotation on radar	--
------------------------------

--presetup
function initArray(m,n)
	local array = {}
	for i = 1, m do
		array[i]=n
	end
	return array
end
v666={}
v666.radar={}
v666.radar.radius=50 --radius of radar
v666.radar.on=initArray(32,true) --turned on/off
v666.radar.arrow=initArray(32,true) --rotation arrow on/off
v666.radar.img1=initArray(1024,0)
v666.radar.img2=initArray(32,0)

--hooks
addhook("always","v666.radar.always")
addhook("startround","v666.radar.start")
--funcs
function v666.radar.imageupdate(iid,id,img,x,y,rot,mode)
	if img[iid]==0 then
		if mode==1 then
			img[iid]=image("gfx/hud_dot.bmp",x,y,2,id)
		else
			img[iid]=image("gfx/rotation_arrow.bmp",x,y,2,id)
		end
	end
		imagepos(img[iid],x,y,rot)
	if mode==2 then
		imagecolor(img[iid],255,255,0)
	else
		imagecolor(img[iid],255,0,0)
		imagescale(img[iid],0.3,0.3)
	end
end
function v666.radar.imagedelete(iid,img)
	if img[iid]~=0 then
		freeimage(img[iid])
		img[iid]=0
	end
end

function v666.radar.show(id)
	local a,x,y
	for i=1,32 do
		if (player(i,"exists")) and (player(i,"team")==3-player(id,"team")) and (player(i,"health")>0) then
			x=(player(i,"x")-player(id,"x"))/8
			y=(player(i,"y")-player(id,"y"))/8
			a=v666.radar.radius/math.sqrt(x^2+y^2)
			if a<1 then
				x=x*a
				y=y*a
			end
			x=x+53
			y=y+53
			v666.radar.imageupdate(id+32*(i-1),id,v666.radar.img1,x,y,0,1)
		else
			v666.radar.imagedelete(id+32*(i-1),v666.radar.img1)
		end
	end
end

function v666.radar.always()
	for id=1,32 do
		if player(id,"exists") and player(id,"team")>0 and (player(id,"health")>0) then
			if v666.radar.on[id] then
				v666.radar.show(id)
			end
			if v666.radar.arrow[id] then
				v666.radar.imageupdate(id,id,v666.radar.img2,53,53,player(id,"rot"),2)
			end
		else
			for i=1,32 do
				v666.radar.imagedelete(id+32*(i-1),v666.radar.img1)
			end
			v666.radar.imagedelete(id,v666.radar.img2)
		end
	end
end

function v666.radar.start()
	v666.radar.img1=initArray(1024,0)
	v666.radar.img2=initArray(32,0)
end